#include <xc.h>

#include "LTlib.h"

#include "module_IO.h"
#include "module_IO.c"

#include "module_I2C.h"
#include "module_I2C.c"

#include "LTlib_delay.h"
#include "LTlib_delay.c"

#include "PCF8563.h"
#include "PCF8563.c"

#include "LCD_44780.h"
#include "LCD_44780.c"

#include "string.h"

#define BT1	PORTBbits.RB4	// +
#define BT2	PORTBbits.RB5	// -
#define BT3	PORTBbits.RB6	// ENTER
#define BT4	PORTBbits.RB7	// ESC

#define ANNO 1
#define MESE 2
#define GIORNO 3
#define ORA 4
#define MINUTI 5

char valore_ok = 0;
int valore, vmin, vmax;
char v = ANNO;
unsigned char frase [16];

int main (void){

 
    IO_set_all_ports_as_inputs ();
	
	IO_enable_pull_up_resistors (IO_PORTB, IO_BIT4 + IO_BIT5 + IO_BIT6 + IO_BIT7);

    LCD_initialize (20);

    LCD_backlight (LCD_TURN_ON_LED);

    LCD_write_message ("Set DATE & TIME");

//    RTCC_initialize(100);	// velocità bus I2C
	
	while (v <= MINUTI){
	
		switch (v){
			case ANNO:{
				vmin = 17;
				vmax = 99;
				valore = 17;
				strcpy (frase, "ANNO AA:");
				break;
			}
			case MESE:{
				vmin = 1;
				vmax = 12;
				valore = 11;
				strcpy (frase, "MESE MM:");
				break;
			}
			case GIORNO:{
				vmin = 1;
				vmax = 31;
				valore = 1;
				strcpy (frase, "GIORNO GG:");
				break;
			}
			case ORA:{
				vmin = 0;
				vmax = 23;
				valore = 17;
				strcpy (frase, "ORA HH:");
				break;
			}
			case MINUTI:{
				vmin = 0;
				vmax = 59;
				valore = 1;
				strcpy (frase, "MINUTI MM:");
				break;
			}
		}
		LCD_goto_line (2);
		LCD_write_message(frase);
		LCD_write_integer (valore, 2, LCD_ZERO_CLEANING_ON);
        valore_ok = 0;
		while (!valore_ok){
			if (!BT1){
				delay_ms(100); // ritardo per antirimbalzo
				// se dopo 100ms il pulsante è ancora premuto, allora non si
				// tratta di un rimbalzo
				if (!BT1){
                    if (valore < vmax)
                        valore++; // incremento il valore
					LCD_goto_line (2);
					LCD_write_message(frase);
					LCD_write_integer (valore, 2, LCD_ZERO_CLEANING_ON);
					delay_ms(50);
				}
			}
			if (!BT2){
				delay_ms(100); // ritardo per antirimbalzo
				// se dopo 100ms il pulsante è ancora premuto, allora non si
				// tratta di un rimbalzo
				if (!BT2){
                    if (valore > vmin)
                        valore--; // incremento il valore
					LCD_goto_line (2);
					LCD_write_message(frase);
					LCD_write_integer (valore, 2, LCD_ZERO_CLEANING_ON);
					delay_ms(50);
				}
			}
			if (!BT3){
				delay_ms(100); // ritardo per antirimbalzo
				// se dopo 100ms il pulsante è ancora premuto, allora non si
				// tratta di un rimbalzo
				if (!BT3){
					valore_ok = 1;	// passo al successivo
					delay_ms(50);
				}
			}
			if (!BT4){
				delay_ms(100); // ritardo per antirimbalzo
				// se dopo 100ms il pulsante è ancora premuto, allora non si
				// tratta di un rimbalzo
				if (!BT4){
					valore_ok = 1;	// 
  					v = MINUTI;          // interrompo la sequenza
					delay_ms(50);
				}
			}
		}
		v++;
	}
    // Execute infinite loop
	LCD_clear();
	LCD_backlight (LCD_TURN_OFF_LED);
	while(1){
        LCD_home(); 
        LCD_write_message("Date : ");
//        LCD_write_string (RTCC_get_date());                
        LCD_goto_line(2);
        LCD_write_message("Time : ");
//        LCD_write_string (RTCC_get_time_seconds());
        
        delay_ms (100);
    }
}


