/**
 * \file   rtc.h
 * \author    Pierluigi Rinaldi 
 * \version   V 1.0
 * \date   21 novembre 2017
 *
 * \brief  Inizializzazione RTC HW.
 *
 * \details 
 * Imposdta Anno Mese giorno Ora e minuti.
 * Controlla i dati in input
 */
#ifndef _RTC_H
#define _RTC_H

#include <xc.h> // include processor files - each processor file is guarded.

// Insert appropriate #include <>

#include <LTlib.h>

#include <module_IO.h>
#include <module_IO.c>

#include <module_I2C.h>
#include <module_I2C.c>

#include <LTlib_delay.h>
#include <LTlib_delay.c>

#include <PCF8563.h>
#include <PCF8563.c>

#include <LCD_44780.h>
#include <LCD_44780.c>

#include <string.h>

// Insert declarations

#define ANNO 1
#define MESE 2
#define GIORNO 3
#define ORA 4
#define MINUTI 5

#define BT1	PORTBbits.RB4	// +
#define BT2	PORTBbits.RB5	// -
#define BT3	PORTBbits.RB6	// ENTER
#define BT4	PORTBbits.RB7	// ESC

char valore_ok = 0;
int valore, vmin, vmax;
char v = ANNO;
unsigned char frase [16];

// Comment a function and leverage automatic documentation with slash star star
/**
    <p><b>Function prototype:</b></p>
  
    <p><b>Summary:</b></p>

    <p><b>Description:</b></p>

    <p><b>Precondition:</b></p>

    <p><b>Parameters:</b></p>

    <p><b>Returns:</b></p>

    <p><b>Example:</b></p>
    <code>
 
    </code>

    <p><b>Remarks:</b></p>
 */
// TODO Insert declarations or function prototypes (right here) to leverage 
// live documentation

#endif /* _RTC_H */
